-- Load some default values 
function love.load()
    wf = require 'libraries/windfield'
    world = wf.newWorld(0, 0) 
   camera = require 'libraries/camera'
    cam = camera()
    

    anim8 = require 'libraries/anim8'
    love.graphics.setDefaultFilter("nearest", "nearest")
    sti = require "libraries/sti"
    gameMap = sti('maps/map.lua')
    

     walls = {}
      if gameMap.layers ["Object Layer 1"] then
        for i, obj in pairs (gameMap.layers["Object Layer 1"].objects) do 
          local wall = world: newRectangleCollider(obj.x, obj.y, obj.width, obj.height)
          wall: setType('static')
          table.insert(walls, wall)
         end  
      end
   
    player = {}
    player.collider = world:newBSGRectangleCollider(50, 50, 12, 24, 1)
    player.collider: setFixedRotation(true)
    player.x = 48
    player.y = 48
    player.speed = 150
    player.spriteSheet = love.graphics.newImage('sprites/playertwo-1.png')
    player.grid = anim8.newGrid( 12, 18, player.spriteSheet:getWidth(), player.spriteSheet:getHeight() )

    player.animations = {}
    player.animations.down = anim8.newAnimation( player.grid('1-4', 1), 0.2 )
    player.animations.left = anim8.newAnimation( player.grid('1-4', 2), 0.2 )
    player.animations.right = anim8.newAnimation( player.grid('1-4', 3), 0.2 )
    player.animations.up = anim8.newAnimation( player.grid('1-4', 4), 0.2 )

      
      player.x = player.collider:getX()
      player.y = player.collider:getY()


    player.anim = player.animations.left


    rect = {}
    rect.collider = world:newRectangleCollider(300, 150, 20, 20)
    rect.collider: setFixedRotation(true) 
    rect.x = 300            -- This will render the rectangle at 300px to the right along the x-axis.
    rect.y = 150            -- This will render the rectangle at 150px below along the y-axis.
    rect.w = 20           -- This will render the rectangle with a width of 100px.
    rect.h = 20           -- This will render the rectangle with a height of 100px.
    rect.speed = 30      -- This will give the rectangle a movement speed of 100.


  end

 
function love.update(dt)
    local isMoving = false

    local vx = 0 
    local vy = 0

    if love.keyboard.isDown("d") then
        vx = player.speed
        player.anim = player.animations.right
        isMoving = true
    end

    if love.keyboard.isDown("a") then
        vx = player.speed * -1
        player.anim = player.animations.left
        isMoving = true
    end

    if love.keyboard.isDown("s") then
        vy = player.speed
        player.anim = player.animations.down
        isMoving = true
    end

    if love.keyboard.isDown("w") then
        vy =  player.speed * -1
        player.anim = player.animations.up
        isMoving = true
    end

    player.collider:setLinearVelocity(vx, vy)


    if isMoving == false then
        player.anim:gotoFrame(2)
    end

 if rect.x < player.x then                  -- If the rect is to the left of the circle:
    rect.x = rect.x + (rect.speed * 2.5 * dt)       -- Rectangle moves towards the right.
    end
 
    if rect.x > player.x then                   -- If the rect is to the right of the circle:
    rect.x = rect.x - (rect.speed * 2.5 * dt)       -- Rectangle moves towards the left.
    end
 
    if rect.y < player.y then                   -- If the rect is above the circle:
    rect.y = rect.y + (rect.speed * 2.5 * dt)       -- Rectangle moves downward.
    end
 
    if rect.y > player.y then                   -- If the rect is below the circle:
    rect.y = rect.y - (rect.speed * 2.5 * dt)       -- Rectangle moves upward.
    end


    
    world:update(dt)
    player.x = player.collider:getX()
    player.y = player.collider:getY()
    player.anim:update(dt)

   rect.collider = rect.x, rect.y 

    mapW = gameMap.width * gameMap.tilewidth
    mapH = gameMap.height * gameMap.tileheight
     
    cam:lookAt(player.x, player.y)

   -- This section prevents the camera from viewing outside the background
    -- First, get width/height of the game window
    local w = love.graphics.getWidth()
    local h = love.graphics.getHeight()

    -- Left border
    if cam.x < w/2 then
        cam.x = w/2
    end

    -- Right border
    if cam.y < h/2 then
        cam.y = h/2
    end

    -- Get width/height of background
    local mapW = gameMap.width * gameMap.tilewidth
    local mapH = gameMap.height * gameMap.tileheight

    -- Right border
    if cam.x > (mapW - w/2) then
        cam.x = (mapW - w/2)
    end
    -- Bottom border
    if cam.y > (mapH - h/2) then
        cam.y = (mapH - h/2)
    end

    --cam:lockPosition(player.x, player.y)

  end


-- Draw the graphics.
function love.draw()
    -- 
  cam:attach()
    gameMap:drawLayer(gameMap.layers["Object Layer 1"])
    gameMap:drawLayer(gameMap.layers["Tile Layer 1"])
   love.graphics.rectangle("fill", rect.x, rect.y, rect.w, rect.h)
   world:draw()
  cam:detach()

  cam:attach()
    player.anim:draw(player.spriteSheet, player.x, player.y, nil, 1.5, nil, 6, 9)
        
  cam:detach()
    
   

    love.graphics.print('Version 0.004')

end